PROBLEM LINK:Author: Tuấn Anh Trần Đặng DIFFICULTY:Easy PREREQUISITES:Dynamic Programming ProblemRemove a single number in the sequence to make it an arithmetic progression. SolutionThe number at position i can be removed if the subsequence on its left and right are both arithmetic progression and when when we concat that two parts they still make an arithmetic progression. The first condition can be handled by precalculate f[i] = whether the prefix of i characters of the sequence is arithmetic progression and similarly g[] for the suffixes. Put all the corner cases aside the whole conditions can be represented as f[i] and g[i] and a[i  2]  a[i  1] = a[i  1]  a[i + 1] = a[i + 1]  a[i + 2] (1). detailsWe will use dynamic programming (dp) to calculate f and g. Since they are similar let’s just discuss how to calculate f. Initialize the dp with f[0] = f[1] = f[2] = true. We’ll have that
Before using the formula (1) some corner cases we need to consider is when N ≤ 3, i ≤ 2 and N  2 ≤ i. Complexity is O(N). Author's/Tester's Solutions:
This question is marked "community wiki".
asked 18 Sep '16, 15:56

Answer is hidden as author is suspended. Click here to view.
answered 19 Sep '16, 02:13

I actually had a different type of solution for this. Either we can remove index 1 and see if the remaining sequence is in AP or not. If it is we get one of the possible answers. Now we will definitely make sure index 1 lies in the answer. Now we remove index 2 and see if the sequence is in AP or not. If it is then we get one of the possible answers. Now we definitely include both index 1 and 2 in our solution. This fixes the common difference "d" for our case. Now simply iterate through the array and check for fault positions. If no faulty positions are found, this means the given sequence was already in AP. In such a case find the minimum value in the array which can be removed. If some faulty position is found break at the first one, as we can make exactly one removal. Again after removing these positions check if we get a valid AP or not and update the answer. Answer is the minimum of all the above 4 cases. Here is my solution https://www.codechef.com/viewsolution/11559787 answered 19 Sep '16, 00:25
@likecs i did the way u did but got wa did u got ac
(19 Sep '16, 16:53)
If did not get AC, I would not have discussed the approach in detail, rather asked for help :P. As, per your question, I got AC
(19 Sep '16, 16:59)

The test cases for this problem are weak. Here is my accpeted solution : https://www.codechef.com/viewsolution/11562158 but it fails on the following test case: 1 7 2 3 6 8 13 15 18 The answer for the above test case is 1 but my accepted solution gives 2 (link text) answered 19 Sep '16, 00:32

Yes, Test cases are weak. I have found accepted solutions of people with wrong answers. Test Cases: 1 5 2 4 5 6 8 Given Ans: 1 Right Ans: 5 1 4 2 4 5 6 Given Ans: 5 Right Ans: 2 Some code are giving TLE. I am checking through my compile list Testcase: 14 7 2 3 6 8 13 15 18 3 3 5 7 3 7 5 3 3 1 7 12 3 12 7 1 5 2 6 7 8 11 3 2 7 12 4 2 5 7 11 4 3 6 7 11 6 2 4 6 15 8 10 5 2 4 5 6 8 4 2 4 5 6 2 1 1 4 4 5 6 8 Ans: 1 3 3 1 1 1 2 1 6 15 5 2 1 5 Everyone check your answer against this. I request to recheck all the submission. answered 19 Sep '16, 01:09

Please add the question to practice section @admin @tuananh93 answered 21 Sep '16, 19:31

Can someone rewrite this editorial with a better explanation ? answered 06 Nov '16, 05:19

I used the same approach while the contest was running as this editorial says . but got WA, I also took care of some boundary cases. can anyone tell mistake in my code.? my solution ( I am storing common diff. of the A.P. starting from 0 and ends at pos i in pre[i] else 1 ) thanks in advance :) answered 19 Sep '16, 00:29
Your code fails for this test case 1 5 2 4 6 8 10 Your code gives 10 but actual answer is 2 ( we have to output the smallest number)
(19 Sep '16, 00:36)
thanks! it has been submitted!
(19 Sep '16, 00:42)

Used a different approach. First I find the sum of all the given numbers. Now at each i, I will remove the ith number from the given list (and will subtract it from the cumulative sum too) and will check, whether the new sum obtained is equal to the sum of the first and last elements of the (supposedly) AP multiplied by the number of terms (now N1), and divided by 2 or not. (Since we know that this is the actual formula for sum of all numbers in an AP). This is the first condition. Secondly, we must check whether there exists a common difference or not. For that just check whether the difference between the first and last term in AP, is divisible by (N1) or not (i.e. the difference is an integral multiple of N1). If both conditions are satisfied, we obtain a valid AP. Removing the minimum number clearly means that the sum of all numbers in the AP must be maximum. That can be taken care of. My solution: https://www.codechef.com/viewsolution/11559413 Note that in order to avoid decimal point issues, I am multiplying the LHS in condition 1 by 2 (rather than division on RHS by 2). answered 19 Sep '16, 00:48
